## flye 2.9.1+dfsg

=== Makefile ===
ROOT_DIR := $(shell dirname $(realpath $(lastword $(MAKEFILE_LIST))))
THREADS := 4

export LIBCUCKOO = -I${ROOT_DIR}/lib/libcuckoo
export INTERVAL_TREE = -I${ROOT_DIR}/lib/interval_tree
export LEMON = -I${ROOT_DIR}/lib/lemon
export BIN_DIR = ${ROOT_DIR}/bin
export MINIMAP2_DIR = ${ROOT_DIR}/lib/minimap2
export SAMTOOLS_DIR = ${ROOT_DIR}/lib/samtools-1.9

export CXXFLAGS += ${LIBCUCKOO} ${INTERVAL_TREE} ${LEMON} -I${MINIMAP2_DIR}
export LDFLAGS += -lz -L${MINIMAP2_DIR} -lminimap2

.PHONY: clean all profile debug minimap2 samtools

.DEFAULT_GOAL := all


${BIN_DIR}/flye-minimap2:
	make -C ${MINIMAP2_DIR} -j ${THREADS}
	cp ${MINIMAP2_DIR}/minimap2 ${BIN_DIR}/flye-minimap2

minimap2: ${BIN_DIR}/flye-minimap2

samtools: ${BIN_DIR}/flye-samtools

${BIN_DIR}/flye-samtools:
	cd ${SAMTOOLS_DIR} && ./configure --without-curses --disable-bz2 --disable-lzma --enable-plugins
	make samtools -C ${SAMTOOLS_DIR} -j ${THREADS}
	cp ${SAMTOOLS_DIR}/samtools ${BIN_DIR}/flye-samtools

all: minimap2 samtools
	make release -C src -j ${THREADS}
profile: minimap2 samtools
	make profile -C src -j ${THREADS}
debug: minimap2 samtools
	make debug -C src -j ${THREADS}
clean:
	make clean -C src
	make clean -C ${MINIMAP2_DIR}
	make clean-all -C ${SAMTOOLS_DIR}
	rm -f ${BIN_DIR}/flye-minimap2
	rm -f ${BIN_DIR}/flye-samtools

=== debian/changelog ===
flye (2.9.1+dfsg-1) unstable; urgency=medium

  * New upstream version

 -- Andreas Tille <tille@debian.org>  Tue, 23 Aug 2022 16:45:19 +0200

flye (2.9+dfsg-2) unstable; urgency=medium

  * Source-only upload
  * Standards-Version: 4.6.1 (routine-update)

 -- Andreas Tille <tille@debian.org>  Thu, 19 May 2022 19:47:57 +0200

flye (2.9+dfsg-1) unstable; urgency=medium

  * Initial release (Closes: #962292)

 -- Andreas Tille <tille@debian.org>  Thu, 05 May 2022 10:16:41 +0200

=== debian/control ===
Source: flye
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-python,
               python3,
               python3-setuptools,
               liblemon-dev,
               libminimap2-dev,
               samtools,
               zlib1g-dev
Standards-Version: 4.6.1
Vcs-Browser: https://salsa.debian.org/med-team/flye
Vcs-Git: https://salsa.debian.org/med-team/flye.git
Homepage: https://github.com/fenderglass/Flye
Rules-Requires-Root: no

Package: flye
Architecture: any
Depends: ${shlibs:Depends},
         ${python3:Depends},
         ${misc:Depends},
         minimap2,
         samtools
Description: de novo assembler for single molecule sequencing reads using repeat graphs
 Flye is a de novo assembler for single molecule sequencing reads, such
 as those produced by PacBio and Oxford Nanopore Technologies. It is
 designed for a wide range of datasets, from small bacterial projects to
 large mammalian-scale assemblies. The package represents a complete
 pipeline: it takes raw PacBio / ONT reads as input and outputs polished
 contigs. Flye also has a special mode for metagenome assembly.

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1
export LC_ALL=C.UTF-8

include /usr/share/dpkg/default.mk

# for hardening you might like to uncomment this:
# export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@ --with python3 --buildsystem=pybuild

override_dh_installchangelogs:
	dh_installchangelogs docs/NEWS.md

### When overriding auto_test make sure DEB_BUILD_OPTIONS will be respected
#override_dh_auto_test:
#ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
#	do_stuff_for_testing
#endif

override_dh_auto_clean:
	dh_auto_clean
	find src -name "*.o" -delete
	rm -f bin/flye-modules
	rm -rf flye.egg-info/

## flye 2.9.2+dfsg

=== debian/changelog ===
flye (2.9.2+dfsg-2) unstable; urgency=medium

  * gcc-13.patch: new: fix ftbfs with gcc-13. (Closes: #1037662)
  * d/control: add myself to uploaders.

 -- Étienne Mollier <emollier@debian.org>  Sun, 13 Aug 2023 10:28:45 +0200

flye (2.9.2+dfsg-1) unstable; urgency=medium

  * New upstream version
  * Standards-Version: 4.6.2 (routine-update)

 -- Andreas Tille <tille@debian.org>  Tue, 11 Jul 2023 17:46:42 +0200

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,7 @@
 Source: flye
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
-Uploaders: Andreas Tille <tille@debian.org>
+Uploaders: Andreas Tille <tille@debian.org>,
+           Étienne Mollier <emollier@debian.org>
 Section: science
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
@@ -11,7 +12,7 @@
                libminimap2-dev,
                samtools,
                zlib1g-dev
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/med-team/flye
 Vcs-Git: https://salsa.debian.org/med-team/flye.git
 Homepage: https://github.com/fenderglass/Flye

## flye 2.9.3+dfsg

=== debian/changelog ===
flye (2.9.3+dfsg-1) unstable; urgency=medium

  * New upstream version
  * Build-Depends: s/dh-python/dh-sequence-python3/ (routine-update)
  * gcc-13.patch: delete: applied upstream.
  * cppflags.patch: new: propagate CPPFLAGS.
    Among other things, this allows injection of source fortification
    macro, which participates to executables hardening.
  * d/rules: activate hardening flags.
  * use_debian_packaged_libs.patch: forward not-needed.

 -- Étienne Mollier <emollier@debian.org>  Wed, 29 Nov 2023 22:45:17 +0100

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Section: science
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
-               dh-python,
+               dh-sequence-python3,
                python3,
                python3-setuptools,
                liblemon-dev,

=== debian/rules ===
--- 
+++ 
@@ -5,11 +5,10 @@
 
 include /usr/share/dpkg/default.mk
 
-# for hardening you might like to uncomment this:
-# export DEB_BUILD_MAINT_OPTIONS=hardening=+all
+export DEB_BUILD_MAINT_OPTIONS=hardening=+all
 
 %:
-	dh $@ --with python3 --buildsystem=pybuild
+	dh $@ --buildsystem=pybuild
 
 override_dh_installchangelogs:
 	dh_installchangelogs docs/NEWS.md

## flye 2.9.3+dfsg2

=== debian/changelog ===
flye (2.9.3+dfsg2-1) unstable; urgency=medium

  [ Étienne Mollier ]
  * d/salsa-ci.yml: disable i386 build.

  [ Andreas Tille ]
  * Drop code copy of six.py
  * Port to Python3.12 by removing vendored six.py
    Closes: #1061797
  * Depends: python3-six

 -- Andreas Tille <tille@debian.org>  Fri, 02 Feb 2024 14:50:39 +0100

=== debian/control ===
--- 
+++ 
@@ -23,6 +23,7 @@
 Depends: ${shlibs:Depends},
          ${python3:Depends},
          ${misc:Depends},
+         python3-six,
          minimap2,
          samtools
 Description: de novo assembler for single molecule sequencing reads using repeat graphs

## flye 2.9.4+dfsg

=== debian/changelog ===
flye (2.9.4+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * Standards-Version: 4.7.0 (routine-update)

 -- Alexandre Detiste <tchet@debian.org>  Wed, 22 May 2024 14:21:21 +0200

## flye 2.9.5+dfsg

=== debian/changelog ===
flye (2.9.5+dfsg-1) unstable; urgency=medium

  * New upstream version 2.9.5+dfsg
  * python3.12.patch: unfuzz.
  * python3.12.patch: forwarding not needed.
    This is because most of the changes are vendoring removal; upstream
    did move to Python 3.12 in the present version.

 -- Étienne Mollier <emollier@debian.org>  Sat, 31 Aug 2024 12:43:43 +0200

=== debian/control ===
--- 
+++ 
@@ -12,7 +12,7 @@
                libminimap2-dev,
                samtools,
                zlib1g-dev
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Vcs-Browser: https://salsa.debian.org/med-team/flye
 Vcs-Git: https://salsa.debian.org/med-team/flye.git
 Homepage: https://github.com/fenderglass/Flye

## flye 2.9.6+dfsg

=== Makefile ===
--- 
+++ 
@@ -10,6 +10,11 @@
 
 export CXXFLAGS += ${LIBCUCKOO} ${INTERVAL_TREE} ${LEMON} -I${MINIMAP2_DIR}
 export LDFLAGS += -lz -L${MINIMAP2_DIR} -lminimap2
+
+ifeq ($(shell uname -m),arm64)
+	export arm_neon=1
+	export aarch64=1
+endif
 
 .PHONY: clean all profile debug minimap2 samtools

=== src/Makefile ===
.PHONY: all clean debug profile

CXXFLAGS += -Wall -Wextra -pthread -std=c++11 -g
CXXFLAGS += -Wno-missing-field-initializers
LDFLAGS += -pthread -std=c++11 -rdynamic

MODULES_BIN := ${BIN_DIR}/flye-modules

profile: CXXFLAGS += -pg
profile: LDFLAGS += -pg
profile: release

release: CXXFLAGS += -O3 -DNDEBUG
release: flye-modules

SANITIZE_FLAGS += -D_GLIBCXX_SANITIZE_VECTOR -U_FORTIFY_SOURCE -fsanitize=address -fno-omit-frame-pointer -fsanitize=undefined
#SANITIZE_FLAGS += -fsanitize=thread -fsanitize=leak -fsanitize=undefined
debug: CXXFLAGS += -Og ${SANITIZE_FLAGS}
#debug: CXXFLAGS += -D_GLIBCXX_DEBUG
debug: LDFLAGS += ${SANITIZE_FLAGS}
debug: flye-modules


#sequence module
sequence_obj := ${patsubst %.cpp,%.o,${wildcard sequence/*.cpp}}

sequence/%.o: sequence/%.cpp sequence/*.h common/*.h
	${CXX} -c ${CXXFLAGS} $< -o $@

#flye-assemble module
assemble_obj := ${patsubst %.cpp,%.o,${wildcard assemble/*.cpp}}

assemble/%.o: assemble/%.cpp assemble/*.h sequence/*.h common/*.h
	${CXX} -c ${CXXFLAGS} $< -o $@

#flye-repeat module
repeat_obj := ${patsubst %.cpp,%.o,${wildcard repeat_graph/*.cpp}}

repeat_graph/%.o: repeat_graph/%.cpp repeat_graph/*.h sequence/*.h common/*.h
	${CXX} -c ${CXXFLAGS} $< -o $@

#flye-contigger module
contigger_obj := ${patsubst %.cpp,%.o,${wildcard contigger/*.cpp}}

contigger/%.o: contigger/%.cpp repeat_graph/*.h sequence/*.h common/*.h
	${CXX} -c ${CXXFLAGS} $< -o $@


#flye-polish module
polish_obj := ${patsubst %.cpp,%.o,${wildcard polishing/*.cpp}}

polishing/%.o: polishing/%.cpp bin/polisher.cpp polishing/*.h common/*h
	${CXX} -c ${CXXFLAGS} $< -o $@

#main module
#main_obj := ${patsubst %.cpp,%.o,${wildcard main/*.cpp}}
main_obj := main.o
flye-modules: ${assemble_obj} ${sequence_obj} ${repeat_obj} ${contigger_obj} ${polish_obj} ${main_obj}
	${CXX} ${assemble_obj} ${sequence_obj} ${repeat_obj} ${contigger_obj} ${polish_obj} ${main_obj} -o ${MODULES_BIN} ${LDFLAGS}

#main/%.o: main/%.cpp assemble/*.h sequence/*.h common/*.h repeat_graph/*.h contigger/*.h polishing/*.h
main.o: main.cpp
	${CXX} -c ${CXXFLAGS} $< -o $@


clean:
	rm -f ${repeat_obj}
	rm -f ${sequence_obj}
	rm -f ${assemble_obj}
	rm -f ${polish_obj}
	rm -f ${contigger_obj}
	rm -f ${main_obj}
	rm -f ${MODULES_BIN}

=== debian/changelog ===
flye (2.9.6+dfsg-1) unstable; urgency=medium

  * New upstream version 2.9.6+dfsg
  * python3.12.patch: normalize dep3 header.
  * use_debian_packaged_libs.patch: normalise Last-Update timestamp.
  * d/control: declare compliance to standards version 4.7.2.
  * distutils.patch: new: replace uses of distutils.

 -- Étienne Mollier <emollier@debian.org>  Wed, 13 Aug 2025 22:20:08 +0200

=== debian/control ===
--- 
+++ 
@@ -12,7 +12,7 @@
                libminimap2-dev,
                samtools,
                zlib1g-dev
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/med-team/flye
 Vcs-Git: https://salsa.debian.org/med-team/flye.git
 Homepage: https://github.com/fenderglass/Flye

=== debian/rules ===
--- 
+++ 
@@ -13,12 +13,6 @@
 override_dh_installchangelogs:
 	dh_installchangelogs docs/NEWS.md
 
-### When overriding auto_test make sure DEB_BUILD_OPTIONS will be respected
-#override_dh_auto_test:
-#ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
-#	do_stuff_for_testing
-#endif
-
 override_dh_auto_clean:
 	dh_auto_clean
 	find src -name "*.o" -delete

=== debian/watch ===
version=4

opts="repacksuffix=+dfsg,dversionmangle=auto,repack,compression=xz,filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
https://github.com/fenderglass/Flye/tags .*/v?@ANY_VERSION@\.tar\.gz
